CheckFrontAnimations

;check if neon in this room
	LD A,(NeonStatus)
	OR A
	CALL NZ,DisplayNeon
	
;check if flames in this room	
	LD A,(FlamesStatus)
	OR A
	CALL NZ,DisplayFlames
	
;check if bad guy is shooting
	LD A,(ShootHereStatus)
	OR A
	CALL NZ,BadManShoots
	
	LD A,(BleedingStatus)
	OR A
	CALL NZ,BadManShootsB

;check if player walked into poisonous gas
	LD A,(GasStatus)
	OR A
	CALL NZ,Gas
		
	RET
	
	
;--------------------
DisplayNeon
	LD HL,(NeonHL)
	LD BC,(NeonSize)
	LD DE,32
	
	LD A,(GameCycle)	;time to change neon color?
	AND 00011111b
	OR A
	RET NZ
	
	LD A,(HL)			;determine neon color
	XOR 10000011b		;switch between navy and pink
	
;top side	
	PUSH BC
DisplayNeon2
	LD (HL),A
	INC HL
	DJNZ DisplayNeon2
	POP BC
	
;right
	PUSH BC
DisplayNeon3
	LD (HL),A
	ADD HL,DE
	DEC C
	JR NZ,DisplayNeon3
	POP BC

;bottom
	PUSH BC
DisplayNeon4
	LD (HL),A
	DEC HL
	DJNZ DisplayNeon4
	POP BC	
	
;left
DisplayNeon5
	LD (HL),A
	SUB HL,DE
	DEC C
	JR NZ,DisplayNeon5
	RET
	
NeonStatus	.BYTE 0
NeonHL		.WORD 0	
NeonSize	.BYTE 0	;y
			.BYTE 0	;x
			
;--------------------------------------------
DisplayFlames
	LD B,A				;store flame status = room number
	LD HL,GameCycle
	LD A,(HL)			;time to change flames?
	AND 00001111b
	OR A
	RET NZ

	
	LD DE,Flames1		;determine flame sprite
	LD A,(HL)
	AND 00011111b		;game cycle again
	JR Z,DisplayFlames11	
	LD DE,Flames2
	
DisplayFlames11	
	LD A,B				;flames status-which room
	CP 2
	JR Z,DisplayFlames12
;room1
	LD HL,20681
	LD IY,Flames1Gaps
	LD B,23
	CALL DisplayFlames2
	RET

;room2	
DisplayFlames12
	LD HL,20672
	LD IY,Flames2Gaps
	LD B,23
	CALL DisplayFlames2
	RET
	
;----------
DisplayFlames2
	PUSH BC
	PUSH HL
	PUSH DE
	
	LD A,(IY+0)				;gap in the fire for bridge part?
	CP L
	JR NZ,DisplayFlames21	;no,draw fire
	INC IY
	JR DisplayFlames22		;skip drawing fire at this position

DisplayFlames21	
	CALL DrawTile			;draw one flame sprite
	
DisplayFlames22	
	POP DE
	POP HL
	POP BC
	INC L
	DJNZ DisplayFlames2
	RET
	
FlamesStatus
	.BYTE 0

Flames1Gaps
	.BYTE 203,208,217,0
Flames2Gaps
	.BYTE 198,207,212,0



Flames1
	.BYTE 1,2
	.BYTE	  0, 64, 64, 66, 66,230,231,255
	.BYTE	254,238,108, 72,  0,  0,  0,  0
	.BYTE	 70, 86
Flames2
	.BYTE 1,2
	.BYTE	  0,  2,  2, 66, 70, 70,231,255
	.BYTE	239,239,198, 68,  0,  0,  0,  0
	.BYTE	 70, 86
	
;----------------------------------
BadManShoots

;gun animation	
	LD A,(GameCycle)
	AND 00011111b
	CP 4
	JR C,BadManShoots2
	
	LD DE,Water			;clear gun fire
	LD HL,20480+112
	CALL DrawTile
	RET	

BadManShoots2			
	CP 1
	JR NZ,BadManShoots3
	EI
	HALT
	CALL SoundA			;shooting sound
	DI
	
BadManShoots3
	LD DE,GunFire		;draw gun fire
	LD HL,20480+113
	CALL DrawTile
	
	LD B,12
	CALL LoseEnergyFromShot	
	RET

;------------
BadManShootsB
;losing energy from bleeding being in other locations, far
;from shooting man	
	LD B,3
	CALL LoseEnergyFromShot	
	RET
	
;------------
LoseEnergyFromShot		
;player loses energy,B - nr of energy
	LD A,(GameCycle)
	AND 00011111b
	CP 3
	RET NZ
	CALL DecreaseEnergy
	RET
	

GunFire:
	.BYTE 1,1
	.BYTE	  0,  28,126, 28,  0,  0,0,0
	.BYTE	 66
	
;-----------------------	
Gas
	LD A,(OldPlayerPos)	;A - player L position
	AND 00011111b;		;collumn 0-31
	
	CP 12				;position in the middle of the screen
	RET C
	CP 19
	RET NC 
	
;check if player has gas mask
	LD A,(ChosenItem)
	CP 16
	RET Z
	LD A,(UnchosenItem)
	CP 16
	RET Z
		
;death from gas
	LD A,45
	CALL TypeMessage
	JP GameOver
	
	