		
;Routines which deal with events occuring after pressing FIRE are here
		
;1 Go through door to another room
;2 Type text message
		
Events
	LD HL,(CurrentEvents);start of events data
			
;---------------------
Doors 
;check if player stands next to door when fire pressed
;if so, go to proper room		
	LD D,(HL)
	INC HL
	LD E,(HL)		;DE loaded with position where player should stand to go through door
			 
	
	LD A,D
	OR A			;if A=0, then no more doors in this room, so go to next events
	JR Z, Actions	
	
	CALL ComparePlayerPosition	;check if player is close to door
	OR B
	JR NZ,Doors2	;only when B=0 hero is close to door
					;in other case test next door
	
;standing close to door is confirmed so	go to new room
	INC HL
	LD E,(HL)
	INC HL
	LD D,(HL)			;DE loaded with address of new room
	
	INC HL
	LD B,(HL)
	INC HL
	LD C,(HL)			;BC loaded with new position
		
	CALL GoIntoNewLocation	;go through door
	
;return to key reading routine
	RET	

Doors2
; skip this door data and go to next door data
	LD DE,5	
	ADD HL,DE
	JR Doors		
		

;----------------------------		
Actions
;check if an action should happen when fire pressed	(action will happen if player stands in action area)
	
	LD D,(HL)
	INC HL
	LD E,(HL)			;DE loaded with next action area position
	INC HL
	LD A,D
	OR A				;if A=0, then no more actions in this room, go to pick/drop item routines
	JR Z, ItemEvents
		
	CALL ComparePlayerPosition		;checks if player is in action area
	OR B
	JR NZ,NextAction	;only when B=0 player is standing in message area
						;otherwise test next message	
	JR MakeAction
		
NextAction
;skip this action data  and go to next action in this room
	INC HL
	INC HL	
	JR Actions
	
MakeAction
;load address where action code begins		
	LD E,(HL)
	INC HL
	LD D,(HL)
	EX DE,HL			;HL loaded with action code address
	JP (HL)				;execute action code
		

;-------- ITEMS EVENTS--------------------
; if player is close to item, pick it up 
;(if any item already held, player exchanges items)		
;if player not close to any item, drop held item		

ItemEvents
	CALL TakeItem		;take or exchange items
						
;TakeItem routine  set A to 1 if item taken and to 0 if not
	OR A	
	JR NZ,ItemEvents2	;item picked so don't drop anything
	
	CALL DropItem
		
ItemEvents2
	RET 				;return to reading keyboard			
				
	
	
;------------------------
ComparePlayerPosition
;check if player is standing close to given position
	;DE: checked  position
	;BC: used
	;result B=0 if player close to position, B>0 if not	
	
	LD B,0
	LD A,(OldPlayerPos+1)
	CP D
	JR NZ,ComparePlayerPosition2			;if A<>D, then player is in different screen segment than checked position
	
;check horizontal condition: (door-2<position<door+1)
;check: (position>door-2)
	LD A,(OldPlayerPos)
	INC A
	INC A
	SUB E
	LD A,0
	ADC A,B	
	LD B,A					;if there was no carry , then  B=0				

;check if position<door+1
	LD A,(OldPlayerPos)
	DEC A
	LD C,A
	LD A,E
	SUB C
	LD A,0
	ADC A,B
	LD B,A					;if no carry, B is still 0		
	RET	
	
ComparePlayerPosition2
	INC B				;positions are different
	RET

