
;POPRAWIC DROP ITEM

;this routine is caled after pressing FIRE
;it was checked before if player can perform some actions or use some objects at his currnt location
;if actions aren't possible he will try to take/drop items

;if finds an object he'll pick it up
;if he finds an item while holding another one he'll pick new object and drop old item
;if he doesn't find a new item he'll only drop an old one or do nothing


TakeItem
;check if player is standing close to item
	LD HL,CurrentRoomItemTable			;start of current room item table
		
;compare positions				
ComparePlayerToItem	
	INC HL 								;skip item number and go to item position
	LD E,(HL)
	INC HL
	LD D,(HL)							;DE loaded with item position
		
	LD BC,(OldPlayerPos)				;BC loaded with player position
	LD A,B
	CP D
	JR NZ,NotCloseToItem
	LD A,C
	CP E								;compare BC to DE
	JR NZ,NotCloseToItem
	

	JR CloseToItem						;player close  to item confirmed
			
NotCloseToItem
	INC HL								;go to next item in current room item list
	LD A,(HL)
	OR A								;0=no more items in current room
	JR Z, EndOfRoomItems
	 		
	JR ComparePlayerToItem

EndOfRoomItems
	XOR A								;set A=0 that means that no item was picked (used by DropItem routine)	
	RET 								;no more items in this room to take, go to 	DropItem routine	
		
;-------------------------
CloseToItem	
;player is standing close to item
;there are 2 possibilities
			;1. player doesn't have selected item - just pick new item
			;2. player has selected item - pick up new item and drop old item
	
;check if 1st or 2nd item in player's inventory is selected
	LD DE,Item1Held
	LD A,(SelectedItem)					;0 = 1st item selected, 1 = 2nd item selected
	OR A
	JR Z,CloseToItem2;
	INC DE								;DE  is an address which stores the number of selected item		
	
CloseToItem2
	LD A,(DE)							;A loaded with number of selected item ,or A=0  if no item in inventory
	OR A								;check if item held
	PUSH AF
	CALL Z,JustPickItem					;no item in inventory, only pick new item
	POP AF	
	CALL NZ,DropOldPickNew				;exchange items
	LD A,1								;set A=1 that means that no item was picked (used by DropItem routine)
	RET 			

;-------------------------
JustPickItem
	CALL TakeItem2 						;pick item
	CALL SoundB
	CALL RefreshCurrentLocation			;draw room again, now without picked item
	CALL ItemDescribtions				;update item describtions
	RET		
		
;-------------------------
DropOldPickNew
	PUSH AF								;store number of kept item
	PUSH DE								;store which item is chosen, 1st or 2nd
	CALL TakeItem2						;picking up item,new item replaces old item
	POP DE								;restore which item is chosen
	LD A,(DE)
	LD B,A								;store picked item in B
	POP AF								
	LD (DE),A							;restore old item in iventory
	
	PUSH BC								;store picked item
	PUSH DE								;store chosen item 
	CALL DropItem						;drop old item and refresh room
	POP DE
	POP BC
	
	LD A,B
	LD (DE),A							;new item  placed again in inventory
	LD (ChosenItem),A
	CALL ItemDescribtions				;update item describtions
	RET										
			
;-------------------------
TakeItem2		
;using item number find memory address where item data begin
	DEC HL;
	DEC HL								;set HL to item number address
	LD A,(HL)
	LD (ChosenItem),A					;store item number
		
	PUSH AF								;store item number
	LD HL,GameItemData-4				;find item data address
	LD B,A
	LD DE,4 							;one item data take 8 bytes
	
FindItemData
	ADD HL,DE							;go to next item	
	DJNZ FindItemData					;repeat until item nr N is reached (address placed in HL)
			
;Delete item from room inventory
;HL points to an address of the room where the item is stored
;to delete item from current room, let's change the room address to unexisting address
;ser item room address to 257(0000000100000001B),there is no room which begins with such address
	LD A,1
	LD (HL),A
	INC HL	
	LD (HL),A		
		
;store item in player inventory
	LD A,(SelectedItem)
	OR A								;1st or 2nd item chosen?
	JR NZ, TakeItemNr2
	
TakeItemNr1
	POP AF
	LD (Item1Held),A
	RET
TakeItemNr2
	POP AF								;restore item number
	LD (Item2Held),A					;and store it  player's inventory	
	RET									;item picking is finished

		
;-------------------------		
DropItem
		
;check if 1st or 2nd item in player's inventory is selected
	LD HL,Item1Held-1
	LD A,(SelectedItem)
	OR A
	JR Z,DropItem2		;1st item selected, do only one INC HL to point to 1st item	
	
	INC HL				;do INC HL twice to point to 2nd item
DropItem2
	INC HL 
				
	LD A,(HL)			;store dropped item number into A
	OR A				;check if any item was held at all, if not just return
	RET Z				;no item = return to keyboard scanning routine
	
	LD B,A				;store dropped item number into B
	LD C,A				;and in C as well
	
	XOR A
	LD (HL),A			;set item in inventory to 0 = no item in inventory
	LD (ChosenItem),A;  ;set chosen item number to 0 too
	
	LD HL,GameItemData-4;using item number find its data address
	LD DE,4 			;one item data take 4 bytes
	
;find item position	
DropItem3
	ADD HL,DE				
	DJNZ DropItem3		; repeat until item nr N is reached	and its address placed in HL	
		
;place dropped item in current location(change item data appropriately)		
	LD DE,(CurrentLocation)					
	LD (HL),E
	INC HL
	LD (HL),D			;write current location address to dropped item data
		
;using player position count item screen position and write it to item data
;item H position= player H position
;item V position = player V position + player height - item height
	

;read item height
	PUSH HL
	LD HL,ItemSprites-2
	
DropItem35
	INC HL				;find item tile address
	INC HL
	DEC C
	JR NZ,DropItem35	
	
	LD C,(HL)	
	INC HL
	LD B,(HL)			;BC loaded with item tile address
	INC BC				;first byte in tile data is tile width, go to the second - tile height
	LD A,(BC)
	LD B,A				;item height (in characters) loaded into B	
	POP HL
	
;count item screen position	
	LD DE,(OldPlayerPos)
	LD A,6				;player height loaded into A	
	SUB B				;subtract item height
	LD B,A; 			;store result in B for a loop
	
DropItem4
	LD A,E				;one row down
	ADD A,32
	LD E,A
	JR	NC,DropItem45
	
	LD A,D				;change segment if necessary
	ADD A,8
	LD D,A
	
DropItem45
	DJNZ DropItem4
	
	

DropItem5
;DE contains item screen position now
	
	INC HL				;set HL to item position data

	LD (HL),D			;load new item position to item data
	INC HL
	LD (HL),E	

	CALL SoundB					;restore room with dropped item
	CALL RefreshCurrentLocation		
	CALL ItemDescribtions		;update item describtions	
	RET		
	
;-----------------------
DrawItems
;this routine draws items on screen when player entered a new room
;it also creates table of items positions
;when player presses FIRE, he tries to pick up an item and his position is compared with item positions from the table
;to create the table, a loop goes through all items in the game comparing their room with current room
	LD A,1
	LD (CurrentItemNr),A		;local variable, storing item number, when going through all items in the game
								;start with item nr 1

;HL contains start of table with data about items in current room	
;the table structure is:
	;number of item: 1 byte
	;position where player should stand to pick up item: 2 bytes	
	
;clear item data table;
	XOR A
	LD B,30						;3*10=10 items (table size)
	LD HL,CurrentRoomItemTable			
DrawItems2
	LD (HL),A
	INC HL
	DJNZ DrawItems2		
		
	LD IX,CurrentRoomItemTable
	LD HL,GameItemData	
			
;-----------------------	
DrawOneItem
	LD A,(HL)					;check if end of item list	
	INC HL
	OR (HL)
	DEC HL						;2 bytes - adress of location must be 0 if end of items
	
	OR A						;0 = end of list
	RET Z						;no more items
					
;check if item pointed by HL is in current room
	LD C,(HL)
	INC HL
	LD B,(HL)					;BC loaded with item room address
	INC HL
	LD DE,(CurrentLocation)

;does item room = current room (BC = DE )?	
	LD A,B						;B compare to D, C compare to E, any difference=different rooms, don't draw item
	CP D
	JR NZ,NextItem
	LD A,C
	CP E		
	JR NZ,NextItem
		
;item is in current room, draw item
	LD B,(HL)
	INC HL
	LD C,(HL)					;BC loaded with item position
	
	PUSH BC						;store item position
	PUSH HL						;store item list address
	
;find item sprite adddress		
	
	LD HL,ItemSprites-2
	LD A,(CurrentItemNr)
			
DrawOneItem2
	INC HL						;each address take 2 bytes
	INC HL
	DEC A
	JR NZ,DrawOneItem2
	
	LD E,(HL)
	INC HL
	LD D,(HL)					;DE loaded with item tile address
	
	INC DE
	LD A,(DE)
	LD (ItemHeight),A			;store item height to be used later
	DEC DE	
	
;draw item			
	LD H,B
	LD L,C 						;HL loaded with item screen position			
	
		
	PUSH IX
	CALL DrawTile				;draw item
	
	POP IX
	POP HL						;restore item list address
	POP BC						;restore item position
	
;Count and store in memory where player should be standing to be able to collect just drawn item
;item collecting H position = player H position
;item collecting L position (address of player sprite left upper corner ) = item V position + item height - player height 
;																		  = item V position - (player height - item height)
		
	
	PUSH HL						;store item address in item list
	LD H,B
	LD L,C						;load item position to HL

	LD A,(ItemHeight)			;count: player height-item height
	LD B,A
	LD A,6						;player height
	SUB B
	LD B,A						;(player height-item height) placed in B  	
	
;go B character lines up	
	LD A,L
ItemCollectingPosition
	SUB 32						;one line up		
	JR NC,ItemCollectingPosition2
	
	LD L,A						;store A
	LD A,H
	SUB 8						;change screen segment if necessary
	LD H,A
	LD A,L						;restore A
	
ItemCollectingPosition2
	DJNZ ItemCollectingPosition
	LD L,A
	
		

;Store item data in current room item table	
		
	LD (IX+1),L					;take item collecting position and load it to curent room item table 
	LD (IX+2),H

	LD HL,CurrentItemNr			;load to current room item table item number
	LD A,(HL)
	LD (IX+0),A	

	INC (HL)					;increase item number				
		
;Change IX to point to another item in current room item table 
	INC IX
	INC IX
	INC IX
		
;drawing of this item  is finished, but there may be other items,so repeat the routine	
	POP HL						;restore game item list address	
	
	INC HL						;go to next item
	JR DrawOneItem
	
;-----------------------		
NextItem
;go to next item, if current item isn't present in current room
	PUSH HL
	LD HL,CurrentItemNr	
	INC (HL)					;increase item number	
	POP HL	
	INC HL						;go to next item data (2 bytes
	INC HL
	JR DrawOneItem

;local variables used by item drawing routine				
ItemHeight 		.BYTE 0
CurrentItemNr 	.BYTE 0			



;-----------------------
ChangeSelectedItem
	CALL SoundA					;play swap sound
	
;turn 0->1 and 1->0	
	LD HL,SelectedItem
	LD A,(HL)					;check which item is currently selected
	OR A						;
	JR Z, ChangeSelectedItem2

	DEC (HL)					;selected item=0
	DEC (HL)					;selected item=-1

ChangeSelectedItem2
	INC (HL)					;selected item=0 or selected item=1
	CALL ColorizeDescribtions	;change attribute selection on screen

;swap ChosenItem and UnchosenItem variables
	LD HL,ChosenItem
	LD B,(HL)
	INC HL					;go to unchosen item variable
	LD C,(HL)
	LD (HL),B
	DEC HL					;go to chosen item variable
	LD (HL),C				;chosen and unchosen items swapped			
	RET 					;return to keyboard reading routine	
	
				
;------------------------------	
KillItemHeld
;make item disappear from inventory after using it
	LD HL,Item1Held
	LD A,(SelectedItem)		;A=0 or A=1
	OR A
	JR NZ,KillItemHeld2	

KillItemHeld1
	DEC HL					;set to item 1
KillItemHeld2
	INC HL					;set to item 2

KillItemHeld3					
	XOR A
	LD (HL),A				;write 0 to inventory = erase item
	LD (ChosenItem),A
	CALL ItemDescribtions	;type new item describtions		
	RET

;------------------------------	
;ItemCheat
;cheat that enables to change with arrow keys  item in inventory to any other item
;	EI
;	HALT
;	HALT
;	DI
	
;	LD A,1
;	OUT (254),A 			;border
	
;	CALL GetPlayerInput
;	LD HL, Item1Held

;	BIT 2,A
;	JR NZ,ItemCheatDown		;decrease item number

;	BIT 3,A
;	JR NZ,ItemCheatUp		;increase item number
	
;	BIT 4,A
;	RET NZ					;cheat end
	
;	JR ItemCheat

;ItemCheatDown
;	LD A,(HL)
;	OR A
;	JR Z,ItemCheat
;	DEC (HL)				;change item
;	CALL ItemDescribtions	;type item
;	JR ItemCheat

;ItemCheatUp
;	LD A,(HL)
;	CP 31
;	JR Z,ItemCheat
;	INC (HL)				;change item
;	CALL ItemDescribtions	;type item
;	JR ItemCheat
	

;------------------------------	
InitialiseItems	
;copy items names and initial positions to game item data
;this routine is called at the start of the game and after every game over
	LD HL,InitialItemData
	LD DE,GameItemData
	LD BC,27*4				;number of items*4
	LDIR
	RET			



;------------------------------
GameItemData
;data of objects positions in the game are stored here
;they are copied from initial items data every time, the game is begun
	
Money_ItemData
	.BYTE 0,0,0,0	;two bytes location,two bytes position
Pill_ItemData
	.BYTE 0,0,0,0
Gin_ItemData
	.BYTE 0,0,0,0
Saw_ItemData
	.BYTE 0,0,0,0
Pipe_ItemData	
	.BYTE 0,0,0,0
Block_ItemData
	.BYTE 0,0,0,0
Branch_ItemData
	.BYTE 0,0,0,0
Cloth_ItemData
	.BYTE 0,0,0,0
Spanner_ItemData
	.BYTE 0,0,0,0
Battery_ItemData
	.BYTE 0,0,0,0
Doormat_ItemData
	.BYTE 0,0,0,0
Wire_ItemData
	.BYTE 0,0,0,0
Spectrum_ItemData
	.BYTE 0,0,0,0
Phone_ItemData
	.BYTE 0,0,0,0
Gun_ItemData
	.BYTE 0,0,0,0
Mask_ItemData	
	.BYTE 0,0,0,0
Cookie_ItemData	
	.BYTE 0,0,0,0
Meat_ItemData	
	.BYTE 0,0,0,0	
Collar_ItemData	
	.BYTE 0,0,0,0
Grease_ItemData	
	.BYTE 0,0,0,0
Scissors_ItemData	
	.BYTE 0,0,0,0
Hook_ItemData	
	.BYTE 0,0,0,0
Barrel_ItemData
	.BYTE 0,0,0,0
Key_ItemData
	.BYTE 0,0,0,0
Rose_ItemData
	.BYTE 0,0,0,0
Pendant_ItemData
	.BYTE 0,0,0,0	
Crystal_ItemData
	.BYTE 0,0,0,0	
	
	.WORD 0			;location=0*256+0 - end of items


InitialItemData
;start positions of items
;257- unexisting location - not present on the map at the start

	.WORD 257			;money
	.BYTE 80,219
	
	.WORD 257			;pill
	.BYTE 80,200
	
	.WORD 257			;Gin
	.BYTE 80,187
	
	.WORD 257			;saw
	.BYTE 80,185
	
	.WORD 257			;pipe
	.BYTE 80,147
	
	.WORD SlumExit1		;block
	.BYTE 80,187
	
	.WORD 257			;branch
	.BYTE 80,132
	
	.WORD 257			;cloth
	.BYTE 80,178
	
	.WORD 257			;spanner
	.BYTE 80,201
	
	.WORD 257			;battery
	.BYTE 80,174
	
	.WORD 257			;doormat
	.BYTE 80,179
	
	.WORD WasteDump2	;wire
	.BYTE 80,200

	.WORD 257		;spectrum
	.BYTE 80,181
	
	.WORD 257		;phone
	.BYTE 80,184
	
	.WORD 257			;gun
	.BYTE 80,173
	
	.WORD 257			;mask
	.BYTE 80,200

	.WORD 257			;cookie
	.BYTE 80,205
	
	.WORD 257		;meat
	.BYTE 80,202
	
	.WORD 257		;collar
	.BYTE 80,184
	
	.WORD 257		;grease
	.BYTE 80,187
	
	.WORD Red_4		;scissors
	.BYTE 80,187
	
	.WORD 257
	.BYTE 80,170	;hook
	
	
	.WORD SlumExit2	;barrel
	.BYTE 80,130
	
	.WORD 257
	.BYTE 80,167	;key
	
	.WORD 257
	.BYTE 80,134	;rose
	
	.WORD Sewers8
	.BYTE 80,101	;pendant
	
	.WORD 257		;crystal
	.BYTE 80,87
	
	

ItemNames
;texts with item names
	.WORD Money_Text
	.WORD Pill_Text
	.WORD Gin_Text
	.WORD Saw_Text
	.WORD Pipe_Text
	.WORD Block_Text
	.WORD Branch_Text
	.WORD Cloth_Text
	.WORD Spanner_Text
	.WORD Battery_Text
	.WORD Doormat_Text
	.WORD Wire_Text
	.WORD Spectrum_Text
	.WORD Phone_Text
	.WORD Gun_Text
	.WORD Mask_Text
	.WORD Cookie_Text
	.WORD Meat_Text
	.WORD Collar_Text
	.WORD Grease_Text
	.WORD Scissors_Text
	.WORD Hook_Text
	.WORD Barrel_Text
	.WORD Key_Text
	.WORD Rose_Text	
	.WORD Pendant_Text
	.WORD Crystal_Text		


ItemSprites
;addresses of item sprites
	.WORD Money_Item		;1
	.WORD Pill_Item			;2
	.WORD Gin_Item			;3	
	.WORD Saw_Item			;4	
	.WORD Pipe_Item			;5
	.WORD Block_Item		;6
	.WORD Branch_Item		;7
	.WORD Cloth_Item		;8		
	.WORD Spanner_Item		;9
	.WORD Battery_Item		;10
	.WORD Doormat_Item		;11
	.WORD Wire_Item			;12
	.WORD Spectrum_Item		;13
	.WORD Phone_Item		;14
	.WORD Gun_Item			;15
	.WORD Mask_Item			;16
	.WORD Cookie_Item		;17
	.WORD Meat_Item			;18
	.WORD Collar_Item		;19
	.WORD Grease_Item		;20
	.WORD Scissors_Item		;21
	.WORD Hook_Item			;22
	.WORD Barrel_Item		;23
	.WORD Key_Item			;24
	.WORD Rose_Item			;25
	.WORD Pendant_Item		;26
	.WORD Crystal_Item		;27
	


;------------------------------
CurrentRoomItemTable
	.BYTE 0,0,0,0,0,0,0,0,0,0
	.BYTE 0,0,0,0,0,0,0,0,0,0
	.BYTE 0,0,0,0,0,0,0,0,0,0


;-------------------------------
;item graphics

Money_Item:
	.BYTE 2,1
	.BYTE	255,128,170,148,166,148,128,255
	.BYTE	254,  2,170, 82,202, 82,  2,254
	.BYTE	 68,  4
	
Pill_Item:
	.BYTE 1,1
	.BYTE	 28, 62,127,  0, 85, 42, 28,  0
	.BYTE	 71
	
Gin_Item:
	.BYTE 1,2
	.BYTE	 28, 28,  0, 20, 20, 20, 34, 65
	.BYTE	 93, 93, 89, 85, 73, 85, 99, 62
	.BYTE	  7, 69
	
Saw_Item:
	.BYTE 1,2
	.BYTE	  8, 28, 52, 28, 60, 28, 60, 28
	.BYTE	 60, 28, 60, 28, 52, 28,  8,  0
	.BYTE	 65, 65
	
Pipe_Item:
	.BYTE 1,3
	.BYTE	 24, 36, 36, 24, 36, 56, 52, 56
	.BYTE	 52, 56, 52, 56, 52, 56, 52, 56
	.BYTE	 52, 56, 52, 56, 52, 56, 52, 24
	.BYTE	  5,  5,  5
	
Block_Item:
	.BYTE 2,2
	.BYTE	 63,127,234,215,239,221,251,246
	.BYTE	252, 94,183,235,113,233, 81,161
	.BYTE	253,186,244,233,242,224, 80, 63
	.BYTE	  5, 81,161, 65,133, 33,  2,252
	.BYTE	  7,  7,  7,  7
	
Branch_Item:
	.BYTE 1,3
	.BYTE	 64, 64, 64, 64, 64, 96, 96, 96
	.BYTE	 32, 48, 48, 18, 26, 28, 24, 24
	.BYTE	 88, 56, 24, 24, 24, 48, 48, 48
	.BYTE	  2,  2,  2
	
Cloth_Item:
	.BYTE 2,2
	.BYTE	 64,127, 63, 68,127,119,127,111
	.BYTE	  6,254,252,162,254,170,214,250
	.BYTE	 95,111,222,238,252,252, 60,  0
	.BYTE	125,123, 61, 59, 61, 62, 24,  0
	.BYTE	 71, 71, 71, 71
	
Spanner_Item:
	.BYTE 2,1
	.BYTE	  0,  0,106,234,234,106,  0,  0
	.BYTE	 14, 31,249,240,240,249, 31, 14
	.BYTE	  4,  5
	
Battery_Item:
	.BYTE 2,2
	.BYTE	  0,  0,  0, 28,  0,127, 85,  0
	.BYTE	  0,  0,  0, 56,  0,254, 86,  0
	.BYTE	 95, 95, 83, 95, 95, 95, 64,127
	.BYTE	250,218,138,218,250,250,  2,254
	.BYTE	 67, 67,  5,  5
	
Doormat_Item
	.BYTE 3,2
	.BYTE	  0,127, 64, 95, 95, 93, 90, 85
	.BYTE	  0,255,  0,255,170, 85,170, 85
	.BYTE	  0,254,  2,250,170, 82,170, 82
	.BYTE	 90, 85, 90, 85, 90, 64,127,  0
	.BYTE	170, 85,170, 85,170,  0,255,  0
	.BYTE	170, 82,170, 82,170,  2,254,  0
	.BYTE	 65, 65, 65, 65, 65, 65
	
Wire_Item:
	.BYTE 3,1
	.BYTE	 64, 64,  0, 96, 97, 63, 28,  0
	.BYTE	  0,  0,  0,120,254,135,  1,  0
	.BYTE	  0,  1,  2,  8, 60,240,192,  0
	.BYTE	 69, 69, 69
	
Spectrum_Item:
	.BYTE 2,2
	.BYTE	  0,  0,  0, 63, 97,127,  0,127
	.BYTE	  0,  0,  0,254,255,255,  0,255
	.BYTE	 64, 85, 64, 74, 64, 85, 63,  0
	.BYTE	  1, 85,  1,171,  7, 85,254,  0
	.BYTE	  1,  1, 65, 65
	
Phone_Item:
	.BYTE 2,2
	.BYTE	  16
	.BYTE	  0,  0,  0,  8, 28, 38, 67,130
	.BYTE	  1,  3,  6, 13, 30, 15,  7,  2
	.BYTE	197,106,180,104,208,160, 64,128
	.BYTE	  0, 69, 71, 69
	
Gun_Item:
	.BYTE 2,2
	.BYTE	  0,  0, 31, 63, 56, 63, 92,106
	.BYTE	  0,  8,254,254, 66,252, 64, 64
	.BYTE	 88,175, 88,184, 80,176, 96,  0
	.BYTE	192,128,  0,  0,  0,  0,  0,  0
	.BYTE	 65, 65,  1,  1
	
Mask_Item:
	.BYTE 2,1
	.BYTE	 60, 64,224,252,255,126, 63, 15
	.BYTE	 60,194, 14,127,245,170, 92,240
	.BYTE	 71,  7
	
Cookie_Item:
	.BYTE 2,1
	.BYTE	  1,  6, 13, 30, 61, 62, 63, 31
	.BYTE	192, 32, 16,136, 68,164, 84,248
	.BYTE	 70, 70
	
Meat_Item
	.BYTE 2,1
	.BYTE	  0, 96,240,255,127, 42, 21,  0
	.BYTE	  0,  6, 15,255,254,172, 80,  0
	.BYTE	 67,  3
	
Collar_Item:
	.BYTE 2,2
	.BYTE	  0,  0,  0, 63,106,213,128,128
	.BYTE	  0,  0,  0,248,172, 86,  2,  2
	.BYTE	192,238,196,110, 63, 15,  0,  0
	.BYTE	  6,238, 70,236,248,224,  0,  0
	.BYTE	  1,  1, 65, 65
	
Grease_Item:
	.BYTE 1,2
	.BYTE	  0,  0, 52,122,116,122,126,  0
	.BYTE	126,126, 66, 90, 90, 66,126,126
	.BYTE	 67,  1
	
Scissors_Item:
	.BYTE 1,2
	.BYTE	130,130, 68, 68,108,108, 56, 56
	.BYTE	 40, 40, 68, 68,238,170,170,238
	.BYTE	 69, 69	
	
Hook_Item	
	.BYTE 1,2
	.BYTE	253,253,  0,122,  0, 24, 24, 24
	.BYTE	 24, 12,  6, 67,195,195,103, 62
	.BYTE	 69, 69
	
	
Barrel_Item
	.BYTE 2,3
	.BYTE	  0,127,127,127,  0,255,127,  0
	.BYTE	  0,244,248,244,  0,254,252,  0
	.BYTE	127,127,127,127,127,  0,255,127
	.BYTE	244,248,244,248,244,  0,254,252
	.BYTE	  0,127,127,127,126, 85,  0,255
	.BYTE	  0,244,232,212,168, 84,  0,254
	.BYTE	  6,  6,  6,  6,  6,  6
	
Key_Item
	.BYTE 1,2
	.BYTE	  0, 24, 60,102,195,102, 60, 24
	.BYTE	  0, 24, 24, 24, 24,216, 24,216
	.BYTE	 69, 69
	
Rose_Item
	.BYTE 1,3
	.BYTE	  0,  0, 12, 58, 93, 85, 46, 28
	.BYTE	 34, 28,  8,  8,200,233,235,107
	.BYTE	 10,  8,136,232,105, 43, 10,  8
	.BYTE	 66, 68, 68
	
Pendant_Item
	.BYTE 1,2
	.BYTE	 60, 66, 66, 36, 24,  0, 24,  0
	.BYTE	 60,102,219,177,161,195,102, 60
	.BYTE	 70, 70	
	
Crystal_Item	
	.BYTE 2,2
	.BYTE	  0,  7, 12, 24, 50,100,104, 64
	.BYTE	  0,192, 32, 48, 88,172, 92,188
	.BYTE	 73, 82, 69, 43, 22, 15,  7,  0
	.BYTE	108,220,188, 88,176,224,192,  0
	.BYTE	 71, 69, 69, 69
;--------------------------
;item texts

Money_Text
	.BYTE 35,204,96,82,216,137,99,0

Pill_Text
	.BYTE 130,76,96,18
	
Gin_Text
	.BYTE 19,212,163,5,219,198,217,201,112,0
	
Saw_Text
	.BYTE 98,84,163,5,220,193,184,9
	
Pipe_Text	
	.BYTE 130,80,40,5
	
Block_Text	
	.BYTE 27,206,28,133,161,91,19,15,26,192
	
Branch_Text
	.BYTE 20,129,112,200,1
	
Cloth_Text
	.BYTE 27,15,162,5,152,27

Spanner_Text
	.BYTE 156,1,115,133,144,27
	
Battery_Text
	.BYTE 16,84,161,82,200,27
	
Doormat_Text
	.BYTE 149,66,17,82,217,15,124,141,13,0
	
Wire_Text
	.BYTE 186,82,40,18
	
Spectrum_Text
	.BYTE 214,27,156,5,29,18,171,64
	
Phone_Text
	.BYTE 107,194,75,5,220,8,123,133,5
	
Gun_Text
	.BYTE 130,83,163,204,4
	
Mask_Text
	.BYTE 104,83,88,5
	
Cookie_Text:
	.BYTE 27,207,90,69,0
	
Meat_Text
	.BYTE 152,85,152,71,40,9
	
Collar_Text
	.BYTE 35,199,216,207,99,1,144,15
	
Grease_Text
	.BYTE 60,133,12,197,4
	
Scissors_Text
	.BYTE 152,201,156,207,148,192
	
Hook_Text
	.BYTE 105,65,166,200,123,203,232,4
	
Barrel_Text
	.BYTE 123,4,216,129,148,133,96,0
	
Key_Text
	.BYTE 124,142,13,5,218,197,200,12
	
Rose_Text
	.BYTE 132,133,165,25,220,143,153,64
	
Pendant_Text
	.BYTE 129,78,32,78,160,27
	
Crystal_Text
	.BYTE 110,83,162,67,216,210,204,212,11,0