;--------------------
DrawMenu
;draw menu in upper part of screen
	;clear menu area
	XOR A
	LD HL,16384
	LD (HL),A
	LD DE, 16385
	LD BC, 2047
	LDIR	
		
;draw menu parts	
	LD BC,8193;B=32,C=1
	LD DE,Border01
	LD HL,16544
	CALL TileBlock	
		
;energy border1
	LD HL, 16416
	LD DE,Border02
	PUSH DE
	CALL DrawTile	
	POP DE
	
;% done border 1
	LD HL,16440
	CALL DrawTile
	
;energy border 2
	LD HL,16417
	LD BC,1537;B=6,C=1
	
	PUSH BC
	PUSH DE
	LD DE,Border03
	CALL TileBlock	
	
	
		
;%done border2
	LD HL,16441
	POP DE
	POP BC
	PUSH BC
	CALL TileBlock
	
	POP BC
	LD A,2	
	LD DE,22617
	CALL AttrBlock
		
	LD DE,Border04
	LD B,14
	LD C,1
	LD HL,16425
	CALL TileBlock
	
		
;draw score bar
	LD HL, 16473					;screen position
	LD A,(GameScore)				;score = (0-96)
	CALL DrawBar
	
;draw energy bar
	LD HL, 16449					;screen position
	LD A,(PlayerEnergy)				;energy = (0-96)
	CALL DrawBar
	
;--------------	
ItemDescribtions	

;First item
	LD A,(Item1Held)			
	LD HL,16457						;item nr 1 text screen position		
	CALL TypeItemDescribtion
;Second item
	LD A,(Item2Held)
	LD HL,16489						;item nr 2 text screen position	
	CALL TypeItemDescribtion
	
ColorizeDescribtions
;highlight selected item using attributes
	LD A,(SelectedItem)
	OR A
						
;colorize first line	
	PUSH AF
	LD A,7
	JR NZ,FirstItemLine
	LD A,78
FirstItemLine 
	LD HL,22601
	CALL HighlightMenuLine
	
;colorize second line	
	POP AF
	LD A,7
	JR Z,SecondItemLine
	LD A,78	
SecondItemLine	
	LD HL, 22633
	CALL HighlightMenuLine
	
	RET	;end of menu drawing


;-----------------------
HighlightMenuLine
;fill one menu line with attribute (A=attribute,HL=screen attribute address) 		
	LD (HL),A
	LD D,H
	LD E,L
	INC DE		;DE=HL+1	
	LD BC,13
	LDIR					
	RET	
	
;-----------------------
DrawBar
;draw bar, which shows precent of completed game or player energy
;HL: bar position
;A: bar value

	SRA A 				;A=A/2 because we display walue 0-96 with 48 pixel wide bar
	LD D,A

DrawBar2	
	CP 8				;if A<=8, it means we reached last byte of bar, which isn't full
	JR C,LastBarByte
	
	
	PUSH AF
	LD A,255
	LD B,8
	PUSH HL		
DrawBar3
;draw  full byte
	LD (HL),A
	INC H		
	DJNZ DrawBar3
	POP HL
	INC L				;go to next character
	POP AF
	SUB 8				;change bar width left to be drawn
	JR DrawBar2				
	
LastBarByte
	OR A				;is the last char in bar empty?
	JR NZ,LastBarByte1	

	LD A,L
	CP 71				;don't clear the last char if it would erase border graphics
	RET Z
	CP 95				;test positions for both menus
	RET Z
	
	XOR A				;go and clear the last char
	JR LastBarByte21	

LastBarByte1
	LD B,A	
	XOR A				;find grahpics for last byte of the bar
LastBarByte2
	SCF 				;carry=1
	RRA 				;create in A e.g. 11100000b
	DJNZ LastBarByte2

LastBarByte21			
	LD B,8				;draw last ,not completely full score char
LastBarByte3
	LD (HL),A		
	INC H	
	DJNZ LastBarByte3
	
;clear next byte after bar (important when energy decreases
;not to leave rubbish pixels)	
	LD A,D
	CP 40				;if bar is almost 100% don't clear next byte
	RET NC				;as it would clear menu graphics
	
	INC L				;go to next byte
	LD A,H
	SUB 8
	LD H,A
	
	XOR A
	LD B,8
LastBarByte4
	LD (HL),A
	INC H
	DJNZ LastBarByte4	
	
	RET
	
;----------------------	
IncreaseScore
	;count new score
	LD HL,GameScore
	LD A,(HL)
	ADD A,3
	LD (HL),A

;draw new score bar
	LD HL, 16473		;score bar screen position
	CALL DrawBar
	RET	
	
;--------------	
DecreaseEnergy
;B- number of energy to decrease
	LD A,(PlayerEnergy)
	SUB B
	JP C,GameOver
	LD (PlayerEnergy),A
	LD HL, 16449
	CALL DrawBar
	RET

			

;-----------------------
TypeItemDescribtion
;A: item number

;clear previous describtion
	PUSH HL
	PUSH AF	
	LD DE,ClearItemText
	CALL TypeText
	POP AF
	POP HL

;check if item is held or not	
	OR A	
	RET Z 					;no item -> don't type any describtion and return	

;count item describtion address
	PUSH HL
	LD HL,ItemNames-2
	LD B,A
FindItemDescrib
	INC HL					;go to next item	
	INC HL
	DJNZ FindItemDescrib	;repeat until item nr N is reached	and its address placed in HL	
	

;type new describtion
	LD E,(HL)
	INC HL
	LD D,(HL)				;DE loaded with text address
	POP HL					;HL loaded with text screen position		
	CALL TypeText
	RET	
	
;--------
ClearItemText
;string of 14 spaces used to clear item tex
	.BYTE 222,219,222,219,222,219,222,219,222,192
;-----------------------
;menu graphics

Border01
	.BYTE 1,3
	.BYTE	  0,  0,  0,255,  0,255,255,255
	.BYTE 255,255,255,  0,  0,255,255,255
	.BYTE	255,255,255,  0,255,  0,  0,  0
	.BYTE 5,125,5
	
Border02
	.BYTE 8,3
	.BYTE	  0,  0,  3,  4, 11, 23, 47, 46
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  0,  0,192, 32,208,232,244,116

	.BYTE	 46, 46, 46, 46, 46, 46, 46, 46
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	116,116,116,116,116,116,116,116

	.BYTE	 46, 47, 23, 11,  4,  3,  0,  0
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	  16
	.BYTE	116,244,232,208, 32,192,  0,  0

	.BYTE	 69, 69, 69, 69, 69, 69, 69, 69
	.BYTE	 69, 2, 66, 6,70, 4, 68, 69
	.BYTE	  5,  5,  5,  5,  5,  5,  5,  5

Border03
	.BYTE	1,3
	.BYTE	  0,  0,255,  0,255,255,255,  0
	.BYTE	  16
	.BYTE	  0,255,255,255,  0,255,  0,  0
	.BYTE	 69,0,5

Border04
	.BYTE 1,4
	.BYTE	  0,  0,  0,255,  0,255,255,  0
	.BYTE	  16
	.BYTE	  16
	.BYTE	  0,255,255,  0,255,  0,  0,  0
	.BYTE	 71, 0, 0,  7
	
	
;--------------------------------
;--------------------------------
StartMenu
;drawing start game menu	
	CALL ClearScreen
	
;type texts	
	LD HL,16552
	LD DE,StartMenuText1
	CALL TypeText
	
	LD HL,18506
	LD DE,StartMenuText2
	CALL TypeText

	LD HL,20647
	LD DE,StartMenuText3
	CALL TypeText
	
MenuControl	
;testing keyboard
	LD BC,63486
	IN A,(C)
		
	BIT 0,A 		;1 - choose keys
	JR Z,SetKeys
		
	BIT 1,A 		;2 - choose joystick	
	JR Z,SetJoystick
			
	BIT 2,A 		;3 - type intro
	JP Z,Intro
	
	BIT 3,A 		;4 - start game
	JP Z,Start2
	
	JR MenuControl
	
;-----------
SetKeys
	XOR A
	LD (GameControl),A	;store chosen control
	CALL SoundA
	JR MenuControl;
	
SetJoystick
	LD A,1
	LD (GameControl),A	;store chosen control
	CALL SoundA
	JR MenuControl

StartMenuText1
	.BYTE 240,147,164,133,45,19,219,198,217,15,123,64
	

StartMenuText2
	.BYTE 250,27,89,89,19,193,145,29,250,91,89,77,132,212,123,157,250,155,75,148,147,221,250,219,157,1,149,0
	
	
StartMenuText3
	.BYTE 241,146,9,129,249,91,106,65,209,193,223,201,249,223,71,200,2
	
;----------SOUNDS--------------		
SoundA
	PUSH BC
	PUSH DE
	;BC AND DE are used
	LD E,180				
SoundA2
	XOR A
	OUT (254),A
	LD B,E
SoundA3
	DEC B
	JR NZ, SoundA3
	SET 4,A
	OUT (254),A
	DEC E
	JR NZ, SoundA2
	;Delay
	LD B,20
SoundA4
	EI
	HALT
	DI
	DJNZ SoundA4
	POP DE
	POP BC
	RET	

SoundB
	LD E,0
SoundB1	
	XOR A
	OUT (254),A
	
	LD B,E
SoundB2	
	NOP
	NOP
	DJNZ SoundB2
	INC E
	
	LD A,16
	OUT (254),A
	LD A,E
	CP 255
	JR NZ,SoundB1
	RET

	
