;------WALK------
;the routine doesn't work the most obvious way
;it doesn't begin with preparing data in buffer and then displaying it
;instead, just after HALT it display earlier prepared sprite and later
;prepares next sprite in buffer

Walk
;A - code of pressed keys 
		
	CP 3												;check if left and right pressed at once
	JR NZ,Walk2
	XOR A
	LD (Joystick),A
	RET 												;if so just stand (returns to main loop)
	
Walk2	

	CALL UpdatePlayerDirection							;check if changing facing direction
	
	EI
	HALT												;start drawing walking sprite with new interrupt	
	DI
		
	LD HL,(OldPlayerPos)
	CALL DrawBackground									;restore background at old position

	
	LD A,(SpriteInSequence)								;play walking sound
	
	CP 13
	JR NZ, WalkSoundEnd
	
WalkSound1	
	XOR A
	OUT (254),A	
	LD B,250
WalkSound2
	DJNZ WalkSound2		
	
	LD A,16
	OUT (254),A
	
WalkSoundEnd		
	
	LD HL,(NewPlayerPos)													
		
	CALL DrawPlayer										;store background	and draw  earlier prepared player sprite at new position							
		
	LD HL,(NewPlayerPos)
	LD (OldPlayerPos),HL 								;new position becomes old position to be used in next loop iteration
	
	

	CALL CheckFrontAnimations							;display animations or objects in front of player
														;END OF DRAWING											


	XOR A												;check  4 bytes below player
	LD (FallDownOption),A
	CALL CheckFallingDown								;after this subroutine: A=0:standing firm	 A=1:falling down	
	OR A
	CALL NZ,FallDown														
	

;-----Prepare player sprite to be displayed in next loop-------------------	

Walk3
	LD A,(Walking)										;walking right or walking left?
	CP 2
	JR Z, WalkLeft

					
WalkRight		
	CALL MovePlayerRight
	OR A		;A=0 -> movement was possible, A=1 -> obstacle was met
	RET NZ		;if obstacle was met, don't count new player frame and return to key reading routine
	JR NewFrame

WalkLeft
	CALL MovePlayerLeft
	OR A		;A=0 -> movement was possible, A=1 -> obstacle was met
	RET NZ		;if obstacle was met, don't count new player frame and return to key reading routine
	
;-----------------------
NewFrame
;Change  frame of player sprite to new frame in walking sequence		
			
			LD A, (SpriteInSequence); position in sequence
			INC A
			CP 25 ;if end of sequence then start from the beginning
			JR NZ,NewFrame2	
			LD A,1
NewFrame2
	LD (SpriteInSequence),A ;New position IN sequence counted AND stored
			
		;find new frame number
			DEC A
			LD DE,SpriteSequence; start of sequence
			
			ADD A,E;
			LD E,A

			LD A,0
			ADC A,D		;if carry happened when ADD A,E 
			LD D,A
			
			LD A,(DE)
			LD (SpriteFrame),A; new sprite frame counted AND stored
		
	;Prepares player sprite to be displayed in next loop execution using data counted above
	
	LD B,A;sprite number
	LD A,(Rotation);rotation
	LD C,A
						
	CALL  PreparePlayerSprite	
	RET	
SpriteSequence .BYTE 2,2,2,2,2,2,3,3,3,4,4,4,5,5,5,5,5,5,4,4,4,3,3,3

;-----------------
UpdatePlayerDirection
;mirror player sprites when it's necessary

	LD (Walking),A			;change walking flag
	LD D,A
	LD A,(Facing)
	CP D					;is walking and facing direction the same?	
		
	CALL NZ,MirrorPlayer	;if not, player sprites must be mirrored					
	
	LD A,(Walking)	
	LD (Facing),A			;update facing direction
	RET
		
;---------------JUMPING---------------------
Jump
;when player is jumping, nothing other can be done (e.g. keyboard in not scanned)
;jumping sequence consists of several stages, all of them are executed one by one

	AND 00000011B;											;extract bits responsible for left/right direction
	OR A													;if A=0, player is jumping straight up, so don't need to mirror the sprites
	CALL NZ, UpdatePlayerDirection							;mirror player sprites if necessary
	
	XOR A
	LD (JumpCeilingCycles),A								;assume that player didn't hit the ceiling
	LD (JumpHitFloor),A										;this variable is used to test if player hit the floor whin falling down while jumping
	

	CALL JumpSpriteIntoBuffer								;place in buffer sprite of jumping player
	
;Jump sequence
;Phase 1 - fast going up
	LD A,1													;nr of phase
	LD B,6													;nr of frames in phase
	CALL Jump2
;Phase 2 - going up
	LD A,2
	LD B,12
	CALL Jump2
;Phase 3 - going down
	LD A,3
	LD B,12
	CALL Jump2
;Phase 4 - fast going down
	LD A,4
	LD B,6
	CALL Jump2	
	
;jump sequence is finished
;end jumping seqence with walking frame
	LD A,(Facing)
	LD (Joystick),A
	RET 													;return to readkeys routine
	
;-------
Jump2
	LD (JumpPhase),A
Jump3	
	PUSH BC
;draw jumping player
	CALL OneJumpFrame
	
	CALL ChangeGameCycle									;change game cycle
	
	POP BC													;restore number of frames in phase
	DJNZ Jump3		
	RET
						
;------------------			
OneJumpFrame
;draw background at old position AND player sprite at new position
	EI
	HALT	
	DI
		
	LD HL,(OldPlayerPos)				
	CALL DrawBackground										; RESTORE BACKGROUND
	
	PUSH HL															
;	CALL CheckBackAnimations								; MAKE ANIMATION BEHIND PLAYER
	POP HL
			
	LD HL,(NewPlayerPos)
	PUSH HL
	CALL DrawPlayer											; DRAW PLAYER
	
	POP HL 													;HL=NewPlayerPos	
	LD (OldPlayerPos),HL									;new position becomes old position
	
	CALL CheckFrontAnimations								;MAKE ANIMATIONS IN FORNT OF PLAYER	
			
		
;change player position
;player may jump left, right or only up
;if he jumps left or right both vertical and horizontal positions are changed
;if he jumps up, only vertical position is changed
	
	
;change player vertical position, change depends on which stage of jump is currently executed
	LD A,(JumpPhase)
	
JumpPhase1					;go up quickly if necessary
	CP 1
	JR NZ,JumpPhase2	
	CALL JumpUp
	CALL JumpUp
	JR JumpChangeHorizontal
	
JumpPhase2					;go up if necessary
	CP 2
	JR NZ,JumpPhase3
	CALL JumpUp			
	JR JumpChangeHorizontal
		
JumpPhase3					;go down if necessary
	CP 3
	JR NZ,JumpPhase4
	CALL JumpDown
	JR JumpChangeHorizontal
				
JumpPhase4					;go down quickly if necessary
	CALL JumpDown
	CALL JumpDown

JumpChangeHorizontal	
;change player horizontal position and rotation for next frame
	LD A,(Joystick)
	CP 9
	JR NZ,JumpChangeHorizontal2
	CALL  MovePlayerRight	;go right if necessary
	JR JumpChangeHorizontal3
	
JumpChangeHorizontal2
	CP 10
	JR NZ, JumpEnd					
	CALL MovePlayerLeft		;go left if necessary
	
	
JumpChangeHorizontal3
	OR A		;A=0 -> movement was possible, A=1 -> obstacle was met
	RET NZ		;if obstacle was met, don't count new player frame and return to key reading routine
	

JumpEnd	
;put into buffer rotated jumping sprite to be used in next loop execution
	LD HL,(NewPlayerPos)
	CALL JumpSpriteIntoBuffer
	RET

;-------------
JumpUp
;change player position one pixel line up	
	LD HL,(NewPlayerPos)
	CALL OnePixelLineUp		;go up
	
	LD A,H
	AND 11111000B
	CP 64					;player hit the playing area ceiling and tries to go into menu segment
	JR Z,JumpUpCeiling		;if it's true don't go up
	
	LD (NewPlayerPos),HL		;store new position
	RET
	
JumpUpCeiling
;player tries to go up but can't because there is menu above him
	LD HL,JumpCeilingCycles
	INC (HL)				;remember number of lines
	RET
	
;---------------
JumpDown
	LD A,(JumpHitFloor)		;don't fall down if player reached the floor
	OR A
	RET NZ
	
	LD HL,JumpCeilingCycles
	LD A,(HL)				;if player hit ceiling, he couldn't go up
	OR A					;so he doesn't go down now
	JR Z,JumpDown2			
							;player hit ceiling	
	DEC (HL)				;decrease waiting time to start falling down
	RET	
JumpDown2
	LD HL,(NewPlayerPos)		;player didn't hit ceiling
	CALL OnePixelLineDown	;change player position one pixel line down	
	LD (NewPlayerPos),HL
	
;check if player reached the floor while falling down
	LD A,1
	LD (FallDownOption),A	;check only 2 middle bytes to prevent blocking
	CALL CheckFallingDown
	OR A					;did player reach the floor
	RET NZ					;he didn't
	
	LD A,1
	LD (JumpHitFloor),A		;set variable - end of falling down
	RET					
;-------------------
JumpPhase			.BYTE 1 		;values 1-4
JumpCeilingCycles	.BYTE 0			;when player tries to jump up but can't (there is game menu above him)
									;remember how many lines he wanted to go up and use this number when falling down
									;don't go down the same number of lines
									
JumpHitFloor		.BYTE 0

;-----------------------
MovePlayerRight
;Change rotation (two pixels)
	LD A, (Rotation)
	INC A
	INC A
	
;check if position should be changed		
	CP 8
	JR NZ, MovePlayerRight3;if not, only store rotation
		
	LD HL,(NewPlayerPos)
		
;check if player reached an obstacle (in that case dont walk more)	
	LD A,L
	AND 00011111B
	CP 28 					;if player is close to screen edge, don't check obstacles, let him leave the screen
	JR Z,MovePlayerRight2
	
	PUSH HL
	LD A,L
	ADD A,4
	LD L,A					;count right edge of player sprite
	CALL CheckObstacle
	POP HL
	OR A					;after subroutine A indicates status of obstacles
	JP NZ,ObstacleMet		;don't walk if obstacle is met
					
;going right so increase position		
MovePlayerRight2	
		INC L
		LD (NewPlayerPos),HL
		
;check if reached right screen border
		LD A,L
		AND 00011111b
		CP 29		
		CALL Z,GoNextScreenRight
		XOR A 				;rotation set to 0	
		
MovePlayerRight3
		LD (Rotation),A
		XOR A				;A indicates that movement was possible
		RET

;-----------------------
MovePlayerLeft
;change rotation (two pixels)
	LD A, (Rotation)
	DEC A
	DEC A
	
;check if position should be changed		
	CP 254
	JR NZ, MovePlayerLeft3			;if not, just store rotation
		
	LD HL,(NewPlayerPos)
		
;check if player reached an obstacle (in that case dont walk more)	
	LD A,L
	AND 00011111B
	CP 0 							;if player is close to screen edge, don't check obstacles, let him leave the screen
	JR Z,MovePlayerLeft2

	PUSH HL
	DEC L							;change position
	CALL CheckObstacle
	POP HL
	OR A							;after subroutine A indicates status of obstacles
	JP NZ,ObstacleMet				;don't walk if obstacle is met
	
;going left so decrease position
MovePlayerLeft2
		DEC L
		LD (NewPlayerPos),HL
		
;check if reached left screen border
		LD A,L
		AND 00011111b				;A is from 0 to 31 screen collumn
		CP 0						
		CALL Z,GoNextScreenLeft
		CP 31						
		CALL Z,GoNextScreenLeft	
		
		LD A,6						;rotation set to to 6
		
MovePlayerLeft3 
		LD (Rotation),A
		XOR A						;A indicates that movement was possible
		RET


;-----------------------
;CHECK OBSTACLE
;checks if player while walking encounters an obstacle (like wall), which doesn't allow him to walk more in that direction
;the obstacles are tiles stored in special way: value of paper>value of ink
CheckObstacle
;turn graphic address to attribute address
		LD A,H
		AND 11111000B			;turn H into 64, 72 or 80 (first byte of character)
		LD H,A					;it is important when counting obstacles while jumping
		
		LD A,80
		SRL H
		SRL H
		SRL H
		ADD A,H
		LD H,A

;check if that address contains attribute where paper>=ink
		LD B,6
		LD DE,32
		
CheckObstacle2		
		LD A,(HL)
		AND 00000111B
		LD C,A					;extract ink
		
		LD A,(HL)
		AND 00111000B;
		SRL A
		SRL A
		SRL A					;extract paper
		
		CP C					;compare  paper to ink
		JR NC,CheckObstacle3	;no carry -> paper>=ink
		

		ADD HL, DE				;go one character line down
		DJNZ CheckObstacle2		;check obstacles from top to bottom of the player
			
		XOR A					;all checked and no obstacle found
		RET
	
CheckObstacle3
		;LD A,0					;cheat - walk through walls
		LD A,1 					;obstacle met
		RET		
;----------------
ObstacleMet
;code jumps here when player meets an obstacle
;he doesn't go more in chosen direction in that case
	LD A,(Rotation)
	LD C,A
	LD A,(SpriteFrame)	
	LD B,A						;number of sprite						
	CALL  PreparePlayerSprite	
	LD A,1						;A indicates that player met an obstacle
	RET							;return to key reading routine
	
;----------------------------------------
;CHECK FALLING DOWN
;we need to checks the 4th row of pixels in lowest char line of player sprite

;if there are some pixels (A<>0) it means that there are player's legs in that position
;if so, we must check if there is solid ground below them (check by attribute)
;if both conditions are true for one or more of squares, it means player isn't falling down
;we check 6th row and not the lowest 7th because while jumping 6th and 7th rows are empty
;and while walking 5th row is empty (pause between bots and trousers)

;check if player may fall down
CheckFallingDown
	LD HL,(NewPlayerPos)
	
;load into DE address of the lowest row of pixels in player's sprite	
	LD A,L
	ADD A,5*32
	LD E,A
	LD A,H
	JR C,CheckFallingDown1	;carry=next screen segment
	ADD A,4					;no new screen segment, go to 4th pixel row in char line
	JR CheckFallingDown2
	
CheckFallingDown1	
	ADD A,8+4				;go to 4th row of pixels and change segment			

CheckFallingDown2
	LD D,A					;DE points to lowest row of pixels now

		
;load into 	HL address of square attribute just below the player
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A 					;transform graphics address to attribute address
	
	LD A,L
	ADD A,6*32				;go to byte just below player
	LD L,A
	JR NC,CheckFallingDown3	
	INC H					;change screen segment if necessary

;check  squares below player if any contains solid ground
CheckFallingDown3	
	LD A,(FallDownOption)	;shall we check all 4 bytes or only 2 middle bytes below player?
	OR A
	JR NZ,FallDownOption2	

FallDownOption1	
	LD B,4
	JR CheckFallingDown4

FallDownOption2
	INC L
	LD B,2	
	
	DISPLAY CheckFallingDown4	
			
CheckFallingDown4
	LD A,(DE)				;if there aren't any pixels in that byte (A=0), it means that player's legs
	OR A					;aren't in this position, so it doesn't matter if there is a solid ground
	JR Z,CheckFallingDown5	;below it, just skip checking this position

;check if there is solid ground below player
	LD A,(HL)				;load attribute of byte below player
	
	AND 00000111B
	LD C,A					;extract ink
	
	LD A,(HL)
	AND 00111000B;
	SRL A
	SRL A
	SRL A					;extract paper
		
	CP C					;compare  paper to ink
	
	JR NC,FoundSolidGround	;ground under feet detected
	JR Z,FoundSolidGround	;ground under feet detected
	
CheckFallingDown5	
	INC E					;next byte of player sprite
	INC L					;next square below player
	DJNZ CheckFallingDown4
	
;failed to found solid ground=falling down
	LD A,1					
	RET
	
FoundSolidGround	
	XOR A
	RET
	

;when walking there are 4 bytes below player checked,to enable perfect pixel match
;but when falling down player sprite is changed and it may mean sometimes that
;it would block, so when already falling down only thwo middle square are chechked
;0-all 4 bytes, 1 only 2 middle bytes

FallDownOption	.BYTE 0


;----------------------------------------
;FALLING DOWN

FallDown
	CALL JumpSpriteIntoBuffer		;the same sprite for falling as for jumping
	
FallDown1	
	EI
	HALT
	DI
	LD HL,(OldPlayerPos)				
	CALL DrawBackground										; RESTORE BACKGROUND
	
	PUSH HL															
;	CALL CheckBackAnimations								; MAKE ANIMATION BEHIND PLAYER
	POP HL
			
	LD HL,(NewPlayerPos)
	PUSH HL
	CALL DrawPlayer											; DRAW PLAYER
	
	POP HL 													;HL=NewPlayerPos	
	LD (OldPlayerPos),HL									;new position becomes old position
	
	CALL CheckFrontAnimations								;MAKE ANIMATIONS IN FRONT OF PLAYER	
	CALL ChangeGameCycle
	
	LD A,1
	LD (FallDownOption),A									;check only 2 middle bytes to prevent blocking
	CALL CheckFallingDown
	OR A
	JR NZ,FallDown2											;1=no solid ground below

;0=found solid ground - stop falling down and return to walking routine	
	LD HL,(NewPlayerPos)									;sometimes player goes into ground
	LD A,H													;correct it
	AND 11111000B
	LD H,A
	LD (NewPlayerPos),HL
	RET
	
							
FallDown2		
;change position
	LD HL,(NewPlayerPos)		
	LD (OldPlayerPos),HL									;new position become old position for next frame
	
	CALL OnePixelLineDown									;change player position one pixel line down	
	LD (NewPlayerPos),HL
	
	CALL FallDownDeath										;player reached a bottom of the screen=death
	JR FallDown1
	
;------
FallDownDeath
;bottom screen line means h=80, l>224
;the player coordinates are then h=80,l>64	
	LD A,H					;check h
	CP 80
	RET NZ					;player is safe
	
	LD A,L					;check L
	CP 64					
	RET C					;player is safe

;bottom line reached - death
	LD A,103
	CALL TypeMessage
	JP GameOver	
	
	
;---------------
ChangeGameCycle
;change game cycle
	LD HL,GameCycle
	LD A,(HL)
	INC A
	LD (HL),A
	RET