	DEVICE ZXSPECTRUM128

	ORG 23990

Start
;set interrupt
 DI
 
 LD A,24
 LD (65535),A
 
 LD A,251
 LD (65524),A
 
 LD HL,77*256+237
 
 
 LD (65525),HL

 LD A,252			;252*256=64512
 LD I,A				;the adress of interrupt code is stored at (I*256+N) (N: random value 0-255)
 					;it is memory area 64000-64257 filled with 255
 					;so the intterrupt code start will be at address 255*256+255 = 65535
 					;the next byte from 65535 is byte 0 which is in ROM and has value 243
					;so the instruction being read will be 24,243 that is JR 65524
					;and at 65524 address we have 251,237,77 which is EI,RETI command - end interrupt
					;each interrupt automatically disables interrupts, so they must be enabled again
 LD SP,65516
 IM 2

;copy some graphics to printer area and system variables 
	LD HL,IntroPic4Temp
	LD DE,IntroPic4
	LD BC,633
	LDIR 						
 
 
;--------------------------
Start1
	DI	
	LD SP,65516
	LD A,(Facing)
	CP 2							;facing left?
	CALL Z,MirrorPlayer				;if so, mirror all player's sprites
	
	
;clear game variables and player sprite buffer
;0 mean variable is set to its initial state	
	XOR A
	LD HL,BackgroundBuffer
	LD DE,BackgroundBuffer+1
	LD BC,512+192	;2 buffers 256 bytes each
					;plus 3rd buffer - 192 bytes are player sprite, the rest is used for stack and so untouched							
	LD (HL),A
	LDIR					

	CALL InitialiseItems	;copy initial items positions to their positions used in game
	
	;JP BarMeet
	JP StartMenu 		;go to game menu
;-------------------------
Start2	  
;the game jumps here when start game was chosen from menu	
			

	CALL ClearScreen
	
;-------------------
;set some initial values 
	LD HL,20536						;player position
	;LD HL,72*256+8
	
	LD (OldPlayerPos),HL
	LD (NewPlayerPos),HL
	
	LD A,(Facing)
	CP 1							;facing left?
	CALL Z,MirrorPlayer				;if so, rotate all player's sprites
	
	LD A,1
	LD (Walking),A					;initially player is walking, flag set to 1	
	LD (SpriteInSequence),A			;position of player sprite in walking sequence (1-15)
	LD (SpriteFrame),A				;player sprite frame (1-4) 
	LD (Facing),A					;facing right
	LD A,96
	LD (PlayerEnergy),A
	
	
;--------------------
;Draw first location
	CALL DrawMenu	
	
	LD HL,SlumAlley2
	
	
	CALL DrawLocation
	CALL DrawItems
	
	
;Draw player in standing position for the first time
	;we can't call the usual player drawing routine as it restores the background from the buffer
	;which at the game start is empty
	CALL FirstStandInPlace
	
;---------CONTROL THE PLAYER---------
;------THE MAIN LOOP OF THE GAME-----		
				
MainLoop	
		CALL ChangeGameCycle		
					
		;LD BC,65022						;check item cheat
		;IN A,(C)
		;BIT 1,A							;letter "S" pressed
		;CALL Z,ItemCheat
		
MainLoop2
																		 
		CALL GetPlayerInput

CheckSwap		
;Check if down(swaping items) is pressed
		BIT 2,A
		JR Z,CheckEvents;no down pressed
		CALL ChangeSelectedItem																;DOWN - CHANGE SELECTED ITEM
		JR Standing2
		
CheckEvents
		BIT 4,A ;check if fire is pressed													ACTION (FIRE PRESSED)
		JR Z, CheckMoving ;no fire pressed, so maybe walk
		
		CALL Events		;do different things like talking, walking doors,using items
		JR Standing2	;after that change player's frame to standing
		
CheckMoving		
		BIT 3,A ;check jumping																JUMPING
		CALL NZ, Jump
		
		;no events and no jumping, so walking or standing
		LD A,(Joystick)
		AND 3; only 2 first bits are important
		OR A; checks if A=0 (standing)or A<>0 (walking)
		CALL NZ,Walk ;goes to walking routine												WALKING
	

Standing
		LD A,(Joystick)
		; A=0 means no walking and no jumping so draw  player in standing position
		;if A<>0, player was moving and was already drawn so don't draw him in standing position
		OR A
		JR NZ,MainLoop
Standing2
		;draw player standing
		CALL StandInPlace																	;STAND
		JR MainLoop	
		
		
;------------------------------		
GetPlayerInput
	LD A,(GameControl)
	OR A						;keyboard or joystick
	JR Z,KeyboardControl
	
JoystickControl
	LD BC,31
	IN A,(C)
	LD (Joystick),A		
	RET
	
KeyboardControl
;the aim is to Set bits of A as it would be joystick input
	LD D,0
	LD BC,57342; O,P	
	IN A,(C)
	CPL
	AND 00000011B
	LD D,A
	LD BC,64510;Q
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	OR D		
	LD D,A		
	LD BC,65022;A
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	OR D
	LD D,A
	LD BC,32766
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	RLA
	OR D ;ready
	LD (Joystick),A	
	RET	

 
 
 
;----------------------------- 	
 	INCLUDE <Graphics1.asm>
 	INCLUDE <Locations.asm>
 	INCLUDE <Locations2.asm>
 	INCLUDE <LocationCode.asm>
 	INCLUDE <Items.asm>
 	INCLUDE <Anims.asm>
 	INCLUDE <Actions1.asm>
 	INCLUDE <Actions2.asm>
 	INCLUDE <Events.asm>
	INCLUDE <Menu.asm>
	INCLUDE <Text.asm>
	INCLUDE <DrawLocation.asm
	INCLUDE <DrawPlayer.asm>
	INCLUDE <MovePlayer.asm>
	INCLUDE <Texts.asm>
	INCLUDE <Texts2.asm>
	INCLUDE <PlayerGraph.asm>
	INCLUDE <Intro.asm>
	INCLUDE <IntroPics.asm>
	INCLUDE <Variables.asm>
	
	

	SAVESNA "SoD2.sna",Start
	SAVEBIN "Sod2.bin",23990,41440