;background,mask and sprite buffers:
	;when going to next data byte in buffer it is enough to do INC E, instead of INC DE
	;it is also easy to go from one buffer to another, just INC D,when DE contains bufffer address
	
	;all buffers are with offset + 2 as we have interrupt vector table which  is 257 bytes long

;(InterruptVector	 EQU 64512	  ;H=252,L=0)
;interrupt vector is defined in IntroPics.asm as one picture is copied from memory used
;as buffer to system variables memory after setting the interrupt		

			
BackgroundBuffer EQU 64768+2  ;H=253,L=0
				 	    	  ;these 256 bytes  store background behind player  (192 bytes)
							  ;remaining 63 bytes are used to store various game variables
							  
											
MaskBuffer	     EQU 65024+2  ;H=254,L=0
							  ;BackgroundBuffer+256
							  ;these 256 bytes store player mask (192 bytes)
							  ;remaining 63 bytes are used to store various game variables
	
SpriteBuffer     EQU 65280+2  ;H=255,L=0
							  ;these 256 bytes store player sprite (192 bytes)
							  ;remaining 64 bytes are used for game stack
							  
							  ;(stack memory begins at 65516, and sprite data ends at 65472
							  ;which leaves 44 bytes for stack memory (stack expands down)
							  ;over it we have at 65524 exit from interrupt code
							  
;------------------------------
;GameVariables
;Player control variables
;they control player movement, posessed items etc.
						
Rotation	 		.EQU 64768+194 
SpriteInSequence 	.EQU 64768+195
SpriteFrame			.EQU 64768+196

OldPlayerPos 		.EQU 64768+197
NewPlayerPos 		.EQU 64768+199

Walking				.EQU 64768+201		;0-standing, 1-walking right, 2-walking left
					  			 		;just like joystick input
Facing				.EQU 64768+202		;left or right, also used when standing
	
LeftEdgeLocation	.EQU 64768+204		;neighbour locations
RightEdgeLocation	.EQU 64768+206
				
CurrentEvents		.EQU 64768+208		;start of events data for current room


CurrentLocation		.EQU 64768+210		;memory adress of current location data
	
PlayerEnergy		.EQU 64768+212

TextEnterLocation	.EQU 64768+213		;should a text message appear when player is entering new location,0-no, other-number of text

Joystick			.EQU 64768+214			;pressed keys
	
SelectedItem		.EQU 64768+215			;0 - first item selected, 1 - second item selected
		

Item1Held			.EQU 64768+216			;items held by player, 0 = no item
Item2Held			.EQU 64768+217						

ChosenItem			.EQU 64768+218			;number of active item (0 - no item)
UnchosenItem		.EQU 64768+219

InitRoomCode		.EQU 64768+220			;address of code executed after drawing room			

GameScore			.EQU 64768+222			;points obtained in game

GameCycle			.EQU 64768+223			;cycle of game 0-255 used to animate objects

GameControl			.EQU 64768+224			;player control - 0 keyboard, 1- joystick	



StoreStack			.EQU 64768+225

;-----------------------------
;game variables
BennyStatus			.EQU 65024+194	
DrunkStatus			.EQU 65024+195	
BranchStatus		.EQU 65024+196
ClothesStatus		.EQU 65024+197
WasteLockStatus		.EQU 65024+198
SpannerStatus		.EQU 65024+199
BatteryStatus		.EQU 65024+200
DoormatStatus		.EQU 65024+201
BasementDoorStatus	.EQU 65024+202
ElectroboxStatus	.EQU 65024+203
BasementPowerStatus	.EQU 65024+204
GayClubStatus		.EQU 65024+205
AliceHouseStatus	.EQU 65024+206
AliceStatus			.EQU 65024+207
RedLightTextStatus  .EQU 65024+208
ChinaEnterStatus    .EQU 65024+209
GasMaskStatus		.EQU 65024+210
TakeSpectrumStatus	.EQU 65024+211
PhoneStatus			.EQU 65024+212	;0-before dealer talk,1-before Benny talk,2 after all talk
CashStatus			.EQU 65024+213
GateStatus			.EQU 65024+214
GinaStatus			.EQU 65024+215
MeatStatus			.EQU 65024+216
DogStatus			.EQU 65024+217
GayStatus			.EQU 65024+218
RefreshStatus		.EQU 65024+219	;0 before checking,1-cant refresh,2-ready to refresh,3-after refresh
ChengStatus			.EQU 65024+220	;0-before cookie,1-after buying cookie
TranslatorStatus	.EQU 65024+221	;0-don't have,don't know that needed    1- don't have,needed    2-have
PhoneBatteryStatus	.EQU 65024+222	;0,1 - ok 2-needs charging 3-after charge
BoothStatus			.EQU 65024+223
OldManStatus		.EQU 65024+224	;0-not in bar  1-in bar
TempleStatus		.EQU 65024+225	;0-may not enter temple  1-may enter temple
GuardianStatus		.EQU 65024+226	;0-nothing happened yet, 1 needing help,2-talked with player,3-got his item back
LaToyaStatus		.EQU 65024+227
ManholeStatus		.EQU 65024+228	;0-don't care about manhole,1-before "open" text, 2,3-try to open,4-opened
GardenStatus		.EQU 65024+229	;0-before initial text,1-trying to open,2-opened
RoseStatus			.EQU 65024+230	;0 not picked,1-picked
BarrelStatus	 	.EQU 65024+231	;0-not dropped,1-dropped
SwitchStatus		.EQU 65024+232	;0-off,not seen,1-off, seen,2-on
GreaseStatus		.EQU 65024+233
BridgeEnterStatus	.EQU 65024+234
PlaceboStatus		.EQU 65024+235
GuruStatus			.EQU 65024+236	;0-before first talk,1-after 1st talk,2-ready to give prize,3-after the prize
BadManStatus		.EQU 65024+237	;0-before talk,1-after talk,shooting at Ron
ShootHereStatus		.EQU 65024+238	;is bad man here and shooting at Ron
BlockadeStatus		.EQU 65024+239	;0-blockade of barrels exists,1-blockade removed
GasStatus			.EQU 65024+240
BleedingStatus		.EQU 65024+241	;losing energy - bleeding from wounds